unit SFUnit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    SaveBtn: TButton;
    LoadBtn: TButton;
    ShowMsgBtn: TButton;
    Memo1: TMemo;
    ComboBox1: TComboBox;
    Button4: TButton;
    procedure SaveBtnClick(Sender: TObject);
    procedure LoadBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ShowMsgBtnClick(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function fileOK : boolean;
    procedure updateComboList;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function TForm1.fileOK : boolean;
var
  s : string;
begin
  result := false;
  s := ComboBox1.Text;
  if s = '' then
     s := 'You must enter a file name'
  else if not FileExists( s ) then
     s := s + ' doesn''t exist'
  else result := true;
  if result = false then
     Memo1.Lines.Add(s);
end;

procedure TForm1.updateComboList;
{ Search for any previously saved "*.dwf" configuration files on disk.
  List them in the drop-down list of ComboBox1 }
var
  sr : TSearchRec;
  res : integer;
begin
  ComboBox1.Items.Clear;
  res := FindFirst('*.dwf', faAnyFile, sr);
  while res = 0 do
  begin
   ComboBox1.Items.Add(sr.Name);
   res := FindNext(sr);
  end;
  FindClose(sr);
  ComboBox1.Text := ComboBox1.Items[0];
end;

procedure TForm1.SaveBtnClick(Sender: TObject);
{ Save components to the file specified in ComboBox1 }
var
  fs : TFileStream;
  i : integer;
begin
  fs := TFileStream.Create( ComboBox1.Text, fmCreate );
  try
    for i := 0 to ComponentCount-1 do
      fs.WriteComponent(Components[i]);
  finally
    fs.Free;
  end;
  UpdateComboList;
end;

procedure TForm1.LoadBtnClick(Sender: TObject);
{ Load components from the file specified in ComboBox1 }
var
  fs : TFileStream;
  i   : integer;
begin
  if FileOK then
  begin
     fs := TFileStream.Create( ComboBox1.Text, fmOpenRead );
     try
       for i := 0 to ComponentCount - 1 do
          fs.ReadComponent(Components[i]);
     finally
       fs.Free;
     end;
  end;
  updateComboList;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  UpdateComboList;
end;

procedure TForm1.ShowMsgBtnClick(Sender: TObject);
var
   i : integer;
begin
   memo1.Clear;
   for i := 0 to (ComponentCount-1) do
   begin
      memo1.Lines.Add( Format( '=== Component %d ===', [i] ) );
      with  TControl(Components[i]) do
         memo1.Lines.Add(  'Name: ' + name );
   end;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
   if fileOK then
      ShowMessage( 'OK, that file exists!' );
end;


end.
